package Controller;

import DBConnection.DBConnection;
import java.sql.*;
import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultListModel;

/**
 *
 * @author Vishal
 */
public class MenuControl {
     
    /**Pull menu data from database in order to display in a list on the interface.
     * 
     * @return 
     */
    public static ArrayList[] getMenuList()
    {
        Connection conn = DBConnection.getConnection();
        ArrayList[] toReturn = new ArrayList[2];
        for(int c = 0; c < 2; c++)
        {
            toReturn[c] = new ArrayList();
        }
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Menu");
        try
        {
            while (result.next()) {
                toReturn[0].add(result.getString(1));
                toReturn[1].add(result.getString(2));
            }
        }
        catch (Exception e) { /* ignore close errors */ }
        finally{
            DBConnection.closeConnection(conn);
            return toReturn;
        }
    }
    
    /**Pull all information for item in menu from database where id is idMenu.
     * 
     * @param id
     * @return 
     */
    public static String[] updateMenuDetails(int id)
    {
        Connection conn = DBConnection.getConnection();
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Menu WHERE idMenu='"+id+"'");
        String[] details = new String[3];
        try {
            while (result.next()){
                details[0] = result.getString(3);
                details[1] = result.getString(4);
                details[2] = result.getString(8);
            }
        } catch (Exception ex) {}
        DBConnection.closeConnection(conn);
        return details;
    }
     
    /**Edit an existing menu item, where the id is the idMenu in the database, with the information passed from the interface, which are the input parameters.
     * 
     * @param id
     * @param foodName
     * @param price
     * @param description
     * @param additional
     * @return 
     */
    public static int editMenu(int id, String foodName, String price, String description, String additional){
        
        int count = DBConnection.executeInsert("UPDATE Menu SET FoodName = '" + foodName
                + "', Price = '" + price
                + "', Description = '" + description
                + "', Additional = '" + additional
                + "' WHERE idMenu = " + id);
        return count;
    }
     
    /**Add a menu item to the database with the information passed from the interface, which are the input parameters.
     * 
     * @param foodName
     * @param price
     * @param description
     * @param additional
     * @return 
     */
    public static int addMenu(String foodName, String price, String description, String inventoryName, String inventoryNumber, String inventoryId, int category){
        int count = DBConnection.executeInsert("INSERT INTO Menu" 
                +"( FoodName , Price , Description , InventoryName , InventoryAmount , InventoryId , Category )"
                + " VALUES " 
                + "('" + foodName + "','" + price + "','" 
                + description + "','" + inventoryName + "','" + inventoryNumber + "','" + inventoryId + "'," + category + ")");
        
        return count;
    }
     
    /**Remove a menu item from the database where id is the id of the menu item in the database.
     * 
     * @param id
     * @return 
     */
     public static int removeMenu(int id)
     {
         int count = DBConnection.executeInsert("DELETE FROM Menu WHERE idMenu = " + id);
         return count;
     }
}
