package Controller;

import DBConnection.*;
import java.sql.*;
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;

/**
 *
 * @author Damon
 */
public class OrderControl {
    
    /**Pull menu data from database in order to display in a list on the interface.
     * 
     * @param FoodName
     * @return 
     */
    public static String[] updateMenuDetail(String FoodName)
    {
        Connection conn = DBConnection.getConnection();
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Menu WHERE FoodName='"+FoodName+"'");
        String[] detail = new String[2];
        try {
            while (result.next()){
                detail[0] = result.getString(3);
                detail[1] = result.getString(4);
            }
        } catch (Exception ex) {}
        DBConnection.closeConnection(conn);
        return detail;
    }
    
    /**Pulls status of order from database in order to display to the interface.
     * 
     * @param orderIdList
     * @return 
     */
    public static String[] updateOrderList(javax.swing.JList orderIdList)
    {
        //have to do: if in lists match..remove element
        DefaultListModel guiIdList = (DefaultListModel)orderIdList.getModel();
        Connection conn = DBConnection.getConnection();
        ResultSet result = DBConnection.executeQuery(conn, "SELECT Status FROM Orders WHERE "
                + "idOrder >= " + Integer.parseInt(guiIdList.firstElement().toString()) + " AND "
                + "idOrder <= " + Integer.parseInt(guiIdList.lastElement().toString()));
        String[] orders = new String[50];
        int i = 0;
        try
        {
            while (result.next()) {
                orders[i] = result.getString(4) + " - " + result.getString(2);
                i++;
            }
        } catch (Exception ex) {}
        DBConnection.closeConnection(conn);
        return orders;
    }
    
    /**Submit the order that has been chosen and is displayed on the interface by inserting the orders into the database.
     * 
     * @param orders
     * @param idList
     * @param id
     * @return 
     */
    public static boolean submitOrder(Object[] orders, javax.swing.JList idList, Integer id)
    {
        DefaultListModel idModel = (DefaultListModel)idList.getModel();
        try
        {
            if ( orders.length != 0 ) // if there is an order
            {
                int i = 0;
                while ( orders.length != i ) // loop through all orders  
                {
                    DBConnection.executeInsert("INSERT INTO Orders ( Name , Status , quantity, idEmployee )"
                            + " VALUES ('" + orders[i].toString().substring(4) + "'," + 0 + ","
                            + Integer.parseInt(orders[i].toString().substring(0, 1)) + "," + id + ")");
                    
                    Connection conn = DBConnection.getConnection();
                    ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Orders");
                    while (result.next())
                    {
                        if ( result.isLast() )                        
                            idModel.addElement(result.getString(1));
                    }
                    i++;
                }
            }
        }
        catch(Exception e){return false;}
        return true;
    }
    
    /**Cancel orders that have been placed based on the id of the orders chosen on the interface, by deleting the entry from the database.
     * 
     * @param OrderedList
     * @param orderIdList
     * @return 
     */
    public static boolean cancelOrder (javax.swing.JList OrderedList, javax.swing.JList orderIdList)
    {
        try
        {
            DefaultListModel guiIdList = (DefaultListModel)orderIdList.getModel();
            List id = OrderedList.getSelectedValuesList();
            Connection conn = DBConnection.getConnection();
            ResultSet result = DBConnection.executeQuery(conn, "SELECT Status FROM Orders WHERE "
                    + "idOrder >= " + Integer.parseInt(guiIdList.firstElement().toString()) + " AND "
                    + "idOrder <= " + Integer.parseInt(guiIdList.lastElement().toString()));
            while (result.next())
            {
                if ( result.getString(1).equalsIgnoreCase("Starting") == false )
                {
                    int i = 0;
                    while( id.isEmpty() != true )
                    {
                        DBConnection.executeInsert("DELETE FROM Orders WHERE"
                                + " idOrder = " + Integer.parseInt(guiIdList.get(i).toString()));
                        id.remove(0);
                        i++;
                    }
                }
            }
        }
        catch(Exception e){e.printStackTrace();return false;}
        
        return true;
    }
    
    /**Updates the quantity of an order in the database based on the item chosen.
     * 
     * @param OrderedList
     * @param menuItem
     * @param qty
     * @param change
     * @return 
     */
    public static boolean updateQuantity (javax.swing.JList OrderedList, String menuItem, int qty, String change)
    {
        DefaultListModel orderModel = (DefaultListModel)OrderedList.getModel();
        try
        {
            if ( change.equalsIgnoreCase("Select Quantity") )
                orderModel.addElement(qty + " - " + menuItem);
            else if ( change.equalsIgnoreCase("Change Quantity") )
            {
                String replaceOrder = qty + " - " + OrderedList.getSelectedValue().toString().substring(4);
                orderModel.setElementAt(replaceOrder, orderModel.indexOf(OrderedList.getSelectedValue()));
            }
        }
        catch(Exception e){return false;}
        
        return true;
    }
    
    public static ArrayList[] getOrderList()
    {
        Connection conn = DBConnection.getConnection();
        ArrayList[] toReturn = new ArrayList[6];
        for(int c = 0; c < 6; c++)
        {
            toReturn[c] = new ArrayList();
        }
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Menu");
        try
        {
            while (result.next()) {
                toReturn[0].add(result.getString(1));
                toReturn[1].add(result.getString(2));
                toReturn[2].add(result.getString(3));
                toReturn[3].add(result.getString(4));
                toReturn[4].add(result.getString(6));
                toReturn[5].add(result.getString(7));
                toReturn[6].add(result.getString(8));
                
            }
        }
        catch (Exception e) { /* ignore close errors */ }
        finally{
            DBConnection.closeConnection(conn);
            return toReturn;
        }
    }
    
    public static ArrayList getOrders()
    {
        Connection conn = DBConnection.getConnection();
        ArrayList toReturn = new ArrayList();
        ResultSet result = DBConnection.executeQuery(conn, "SELECT * FROM Orders WHERE Status != 3 ORDER BY Time");
        try
        {
            while (result.next()) {
                ArrayList temp = new ArrayList();
                String status = result.getString(3);
                switch (status) {
                    case "0":
                        temp.add("Pending");
                        break;
                    case "1":
                        temp.add("Preparing");
                        break;
                    case "2":
                        temp.add("Cooking");
                        break;
                    case "3":
                        temp.add("Done");
                        break;
                }
                temp.add(result.getString(5));
                temp.add(result.getString(6));
                String[] food = result.getString(8).split(",");
                String foods = "";
                String query = "SELECT FoodName From Menu WHERE idMenu = " + Integer.parseInt(food[0]);
                for(int i = 1; i < food.length; i++)
                {
                    query += " OR idMenu = " + Integer.parseInt(food[i]);
                }
                Connection conn2 = DBConnection.openConnection();
                ResultSet name = DBConnection.executeQuery(conn2, query);
                while(name.next())
                    foods += name.getString(1) + ", ";
                temp.add(foods.substring(0,foods.length()-2));
                temp.add(result.getString(1));
                toReturn.add(temp);
            }
        }
        catch (Exception e) {}
        finally{
            DBConnection.closeConnection(conn);
            return toReturn;
        }
    }
    
    public static int updateStatus(int id, int status)
    {
        String time = "";
        try {
            Connection conn = DBConnection.openConnection();
            ResultSet result = DBConnection.executeQuery(conn, "SELECT Time From Orders WHERE idOrder = " + id);
            
            result.next();
            time = result.getString(1);
            
        } catch (Exception ex) {}
        
        int count = DBConnection.executeInsert("UPDATE Orders SET Status = " + status
                    + " WHERE Time = " + time);
        return count;
    }
}
