/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Controller;
import DBConnection.DBConnection;
import java.awt.Color;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import org.jfree.chart.*;
import org.jfree.data.general.DefaultPieDataset;
import org.jfree.chart.plot.*;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
/**
 *
 * @author Damon
 */
public class StatsControl {
    
   
    public static JFreeChart makePie()
    {
        ArrayList[] data = getStats();
        DefaultPieDataset pieDataset = new DefaultPieDataset();
        for(int c = 0; c < data[0].size(); c++)
        {
            if(Integer.parseInt(data[1].get(c).toString()) != 0)
            {
                pieDataset.setValue(data[3].get(c).toString(), Integer.parseInt(data[1].get(c).toString()));
            }
        }
        JFreeChart chart = ChartFactory.createPieChart3D 
        ("Popularity of Foods", pieDataset, true, false, false); // title,data,legend,tootips,urls
        PiePlot3D p=(PiePlot3D)chart.getPlot();
        p.setForegroundAlpha(0.8f);
        return chart;
    }
    
    public static JFreeChart makeLine()
    {
        XYSeries series = new XYSeries("Number of People");
        series.add(10.0, 0.0);
        series.add(11.0, 15.0);
        series.add(11.5, 30.0);
        series.add(12.0, 25.0);
        series.add(13.0, 50.0);
        series.add(13.5, 60.0);
        series.add(17.7, 18.0);
        series.add(18.4, 25.0);
        series.add(19.2, 54.0);
        series.add(22.0, 23.0);
        series.add(23.0, 2.0);
        series.add(24.0, 0.0);
        XYDataset xyDataset = new XYSeriesCollection(series);
        JFreeChart chart = ChartFactory.createXYLineChart
        ("Average Daily Customer Turnout", "Time", "Number of People",
        xyDataset, PlotOrientation.VERTICAL, false, true, false);
        
        return chart;
    }
    
    private static ArrayList[] getStats()
    {
        Connection conn = DBConnection.getConnection();
        ArrayList[] toReturn = new ArrayList[4];
        for(int c = 0; c < 4; c++)
        {
            toReturn[c] = new ArrayList();
        }
        ResultSet result = DBConnection.executeQuery (conn, "SELECT * FROM FoodStats");
        int i = 0;
        try {
            while (result.next()) {
                toReturn[0].add(result.getString(1));
                toReturn[1].add(result.getString(2));
                toReturn[2].add(result.getString(3));
                toReturn[3].add(result.getString(4));
                i++;
            }
            
        } catch (Exception e) {}
        finally{
            DBConnection.closeConnection(conn);
            return toReturn;
        }
    }
    
}
