/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DBConnection;

/**
 *
 * @author Vishal
 */
import java.sql.*;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.Session;
import java.util.logging.Level;
import java.util.logging.Logger;
import DBConnection.DBConnectionPool;

public class DBConnection {
    
    
    /**Opens a tunnel into the server on which the database is located.
     * 
     * @return 
     */
    public static boolean openTunnel()
    {
        Session session= null;
        
        try{
            //Set StrictHostKeyChecking property to no to avoid UnknownHostKey issue
            java.util.Properties config = new java.util.Properties();
            config.put("StrictHostKeyChecking", "no");
            JSch jsch = new JSch();
            session=jsch.getSession("group11", "sweng-1.engr.rutgers.edu", 22);
            session.setPassword("automation");
            session.setConfig(config);
            session.connect();
            int assigned_port = session.setPortForwardingL(3366, "localhost", 3306);
        }
        catch(Exception e){
            System.out.println("Tunneling Failed");
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    /**Opens a connection to the database server.
     * 
     * @return 
     */
    public static Connection openConnection()
    {   
        Connection conn = null;
        
        try{
            //mysql database connectivity
            Class.forName("com.mysql.jdbc.Driver").newInstance();
            conn = DriverManager.getConnection ("jdbc:mysql://localhost:3366/group11", "group11", "automation");
            return conn;
        }
        catch(Exception e){
            e.printStackTrace();
        }
        return null;
    }
    
    /**Executes the query specified on the activate database connection and returns the data retrieved from the database.
     * 
     */
    public static ResultSet executeQuery(Connection conn, String query)
    {
        ResultSet result = null;
        try
        {
            Statement s = conn.createStatement();
            result = s.executeQuery (query); 
        }
        catch (Exception e) { e.printStackTrace(); }
        finally{
            return result;
        } 
    }
    
    /**Inserts and edits entries in the database based on a query that is passed into the method.
     * 
     * @param query
     * @return 
     */
    public static int executeInsert(String query)
    {
        Connection conn = openConnection();
        int count = 0;
        try
        {
            Statement s = conn.createStatement();
            count = s.executeUpdate(query); 
        }
        catch (Exception e) { e.printStackTrace(); }
        finally{
            closeConnection(conn);
            return count;
        }
    }

    /**Closes the open database connection that is passed into the method.
     * 
     * @param conn
     * @return 
     */
    public static Connection closeConnectionHelper(Connection conn)
    {
        if (conn != null)
        {
            try
            {
                conn.close ();
            }
            catch (Exception e) {}
        }
        return conn;
    }
    
    public static Connection getConnection()
    {
        try
        {
            return DBConnectionPool.aquireConnection();
        }
        catch (Exception e) {}
        return null;
    }
    
    public static boolean closeConnection(Connection conn)
    {
        if (conn != null)
        {
            try
            {
                 DBConnectionPool.releaseConnection(conn);
            }
            catch (Exception e) {return false;}
        }
        return true;
    }
}