
import DBConnection.DBConnection;
import Interface.UserInterface;
import java.awt.Toolkit;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import static java.util.concurrent.TimeUnit.*;

/**
 * Main program called when the program is ran, which initiates the graphical user interface and opens connections to the server on which the database is located.
 * @author Damon
 */
public class Main {
    
    private final static ScheduledExecutorService scheduler = Executors.newScheduledThreadPool(1);

    public static void scheduleTask() {
        final Runnable beeper = new Runnable() {
            public void run() {
               // System.out.println("beep");
            }   
        };
        
        final ScheduledFuture schedulerHandle = scheduler.scheduleAtFixedRate(beeper, 0, 1, SECONDS);

        scheduler.schedule(new Runnable() {
            public void run() {
                schedulerHandle.cancel(true);
            }
        }, 24, HOURS);
    }
    
    //
    public static void main(String[] args) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(UserInterface.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(UserInterface.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(UserInterface.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(UserInterface.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        scheduleTask();
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                
                DBConnection.openTunnel();
                UserInterface temp = new UserInterface();
                temp.hideAll();
                temp.setVisible(true);
                temp.begin();
            }
        });
    } 
}
