//
//  APIManager.m
//  AutoInformant
//
//  Created by Eric Gilbert on 4/7/12.
//  Copyright (c) 2012 Mercury Software. All rights reserved.
//

#import "APIManager.h"

@interface APIManager()

@property(nonatomic,retain) NSMutableData *responseData;
@property(nonatomic, assign) int current_pos;
@property(nonatomic, assign) int dataType;
@end


@implementation APIManager
@synthesize responseData;
@synthesize current_pos;
@synthesize menuArray;
@synthesize dataType;
@synthesize searchResults;
@synthesize userType;


static APIManager *sharedInstance = nil;

// Get the shared instance and create it if necessary.
+ (APIManager *)sharedInstance {
    if (sharedInstance == nil) {
        sharedInstance = [[super allocWithZone:NULL] init];
    }
    
    return sharedInstance;
}

// dont allocate new object
+ (id)allocWithZone:(NSZone*)zone {
    return [[self sharedInstance] retain];
}

#pragma mark - APIs

-(void) getMenuItems
{
    if (self.menuArray != nil) 
    {
        [self.menuArray removeAllObjects];
    }
    
	NSString * phpCommand = [NSString stringWithFormat:@"http://sweng-1.engr.rutgers.edu/~group11/mobile/menu.php?user=group11&pass=automation"];
	NSString *url = [NSString stringWithString:phpCommand];
	NSURLRequest *request = [NSURLRequest requestWithURL: [NSURL URLWithString:url] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval: 30.0];
	NSURLConnection *connection = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	if (connection) {
		NSLog(@"HORRAY CONNECTED");
	}    
}

-(void) saveOrder:(NSString *) employeeId customer:(NSString *) customerId orderList:(NSString *) orderList table:(NSString *) tableId timeStamp:(NSString *)dateString 
{

    
	NSString * phpCommand = [NSString stringWithFormat:@"http://sweng-1.engr.rutgers.edu/~group11/mobile/submitOrder.php?customer=%@&employee=%@&table=%@&order=%@&time=%@",customerId, employeeId, tableId, orderList, dateString];
    NSLog(@" %@",phpCommand);
    
	NSString *url = [NSString stringWithString:phpCommand];
	NSURLRequest *request = [NSURLRequest requestWithURL: [NSURL URLWithString:url] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval: 30.0];
	NSURLConnection *connection = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	if (connection) {
		NSLog(@"HORRAY CONNECTED");
	}        
}


-(void) setTableToDirty:(NSString *) tableId 
{
	NSString * phpCommand = [NSString stringWithFormat:@"http://sweng-1.engr.rutgers.edu/~group11/mobile/setTableDirty.php?idTable=%@",tableId];
    NSLog(@"%@",phpCommand);
    
	NSString *url = [NSString stringWithString:phpCommand];
	NSURLRequest *request = [NSURLRequest requestWithURL: [NSURL URLWithString:url] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval: 30.0];
	NSURLConnection *connection = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	if (connection) {
		NSLog(@"HORRAY CONNECTED");
	}        
}


-(void) getOrderStatus:(NSString *) tableId timeStamp:(NSString *) timeStamp
{
    if (self.menuArray != nil) 
    {
        [self.menuArray removeAllObjects];
    }

    NSString * phpCommand = [NSString stringWithFormat:@"http://sweng-1.engr.rutgers.edu/~group11/mobile/orderStatus.php?idTable=%@&time=%@",tableId, timeStamp];
    
    NSLog(@"%@",phpCommand);
    
    NSString *url = [NSString stringWithString:phpCommand];
    NSURLRequest *request = [NSURLRequest requestWithURL: [NSURL URLWithString:url] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval: 30.0];
    NSURLConnection *connection = [[NSURLConnection alloc] initWithRequest:request delegate:self];
    if (connection) {
        NSLog(@"HORRAY CONNECTED");
    }        
}

#pragma mark -

-(void)connection:(NSURLConnection *)connection didFailWithError:(NSError *) error
{
	NSLog(@"didFailWithError");
	NSLog(@" %@",[error localizedDescription]);
	///[parentViewController connectionFailure];
}

-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *) response
{
	NSLog(@"Received Response");
	self.responseData = nil;
	[self.responseData setLength:0];
}

-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
	NSLog(@"Received Data");
	if(responseData == nil){
		self.responseData = [[NSMutableData alloc] initWithCapacity:2048];
	}
	[self.responseData appendData:data];
}

-(void)connectionDidFinishLoading:(NSURLConnection *)connection
{
	NSLog(@"Data completed");
	current_pos = 0;
	NSString *responseString = [[NSString alloc] initWithData:self.responseData encoding:NSASCIIStringEncoding];
    

    [self parseData];
	//NSLog(@"Response String: \n%@", responseString);
	[responseString release];
	///[connection release];
}

-(void) setUserType:(int) type
{
    userType = type;
}


#pragma mark - Parser Routines

-(void) parseData
{
	NSData *xml_data = responseData;
	NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:xml_data];
	if (xml_data) {
		[xmlParser setDelegate:self];
		[xmlParser setShouldProcessNamespaces:NO];
		[xmlParser setShouldReportNamespacePrefixes:NO];
		[xmlParser setShouldResolveExternalEntities:NO];
		[xmlParser parse];
	}else {
        [[NSNotificationCenter defaultCenter] postNotificationName:@"NO_MATCH" object:nil];
    }
	
	[xmlParser release];
}

-(void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *) attributeDict 
{
    if (self.menuArray == nil) 
    {
        NSMutableArray * menu = [[NSMutableArray alloc] initWithCapacity:0];
        self.menuArray = menu;
        [menu release];
    }
    
    if([elementName isEqualToString:@"record"]){
        dataType = MENU_LOADED;
        [self.menuArray addObject:attributeDict];  
	}
    if([elementName isEqualToString:@"status"]){
        dataType = ORDER_UPDATED;
        [self.menuArray addObject:attributeDict];  
	}
	
}

-(void)parser:(NSXMLParser *)parser didEndElement:(NSString*) elementName namespaceURI:(NSString *) namespaceURI qualifiedName:(NSString *) qName {
	// found an ending element
}

-(void)parser:(NSXMLParser *)parser foundCharacters:(NSString*) string {
	// no sure what this could be usefull for but it's called by the parser
}

-(void)parserDidStartDocument:(NSXMLParser *) parser {
	// called when the parser starts
}

-(void)parserDidEndDocument:(NSXMLParser *) parser {
	// called when the parser is done
	NSLog(@"Results %@",self.menuArray);
    switch (dataType) {
        case MENU_LOADED:
            [[NSNotificationCenter defaultCenter] postNotificationName:@"MENU_LOADED" object:self.menuArray];            
            break;
            
        case ORDER_UPDATED:
            [[NSNotificationCenter defaultCenter] postNotificationName:@"TABLE_STATUS" object:self.menuArray];            
            break;            
            
        default:
           // [[NSNotificationCenter defaultCenter] postNotificationName:@"NO_MATCH" object:nil];
            break;
    }

}

- (void)parser:(NSXMLParser *)parser parseErrorOccurred:(NSError *)parseError
{
    dataType = 99;
    [[NSNotificationCenter defaultCenter] postNotificationName:@"NO_MATCH" object:nil];   
}

- (void)parser:(NSXMLParser *)parser validationErrorOccurred:(NSError *)validationError
{
    dataType = 99;
    [[NSNotificationCenter defaultCenter] postNotificationName:@"NO_MATCH" object:nil];    
}

@end
