//
//  CustomerOrderViewController.m
//  AutoServe
//
//  Created by Eric Gilbert on 3/28/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CustomerOrderViewController.h"
#import "MenuTableViewController.h"
#import "APIManager.h"
#import "OrderStatusViewController.h"

@interface CustomerOrderViewController ()
@property (nonatomic, assign) int selectedOrder;
@end

@implementation CustomerOrderViewController
@synthesize tableOrderList;
@synthesize customerTableView;
@synthesize selectedOrder;
@synthesize delegate;
@synthesize selectedTable;
@synthesize payBillButton;
@synthesize orderToolBar;
@synthesize middleSpacer;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
       
    }
    return self;
}

- (id) init
{
    self = [super init];
    if (self != nil) {
             
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    if ([[APIManager sharedInstance] userType] == CUSTOMER_TYPE) {
        [self.navigationItem setHidesBackButton:YES];
        NSMutableArray     *items = [[orderToolBar.items mutableCopy] autorelease];
        [items removeObject: payBillButton];
        [items removeObject:middleSpacer];
        orderToolBar.items = items;        
        
    }
}

- (void)viewDidUnload
{
    [self setCustomerTableView:nil];
    [self setPayBillButton:nil];
    [self setOrderToolBar:nil];
    [self setMiddleSpacer:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
     return [tableOrderList count];  
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        // cell = [[[TableCellView alloc] init] autorelease];
        //cell.frame = CGRectMake(0, 0, 320, 44);
    }
    cell.textLabel.text  = [NSString stringWithFormat:@"Customer %d",indexPath.row +1];
    
    return cell;
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.section == 0) {
        selectedOrder = indexPath.row;
    }
}


#pragma  mark - Customer Order Delegate
- (void)CustomerOrderDidSave:(MenuTableViewController *)controller
{
    NSLog(@"Customer order = %@",controller.customerOrder);
    if (tableOrderList == nil) 
    {
        tableOrderList = [[NSMutableArray alloc] initWithCapacity:0];
    }
    [tableOrderList addObject:controller.customerOrder];
    [self.customerTableView reloadData];
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
	if ([segue.identifier isEqualToString:@"addOrder"])
	{
		MenuTableViewController *menuViewController =  segue.destinationViewController;
		menuViewController.delegate = self;
	}
    
	if ([segue.identifier isEqualToString:@"editOrder"])
	{
		MenuTableViewController *menuViewController =  segue.destinationViewController;
        NSLog(@"Selected Order = %d", selectedOrder);
        selectedOrder = [self.customerTableView indexPathForSelectedRow].row;
        [menuViewController performSelector:@selector(setOrder:) withObject:[tableOrderList objectAtIndex:selectedOrder] afterDelay:0.5];
	}
}

- (void)dealloc {
    [customerTableView release];
    [payBillButton release];
    [orderToolBar release];
    [middleSpacer release];
    [super dealloc];
}

- (void) loadTableOrder:(NSMutableArray *) tableOrder
{
    self.tableOrderList = [NSMutableArray arrayWithArray:tableOrder];
    [customerTableView reloadData];
}

- (IBAction)onPayBill:(id)sender 
{
    float totalPrice = 0.0;
    
    for (NSMutableDictionary * order in tableOrderList) 
    {
        ///NSString * customerId = [NSString stringWithFormat:@"%d",chairNumber];
        // Get selected beverages
        if ([[order  objectForKey:@"beverages"] count] > 0) {
            for (NSMutableDictionary * bev in [order objectForKey:@"beverages"]) {
                totalPrice  += [[bev objectForKey:@"itemPrice"] floatValue];
 
            }
        }
        
        // Get selected entrees
        if ([[order  objectForKey:@"entrees"] count] > 0) {
            for (NSMutableDictionary *entree in [order objectForKey:@"entrees"]) {
                    totalPrice  += [[entree objectForKey:@"itemPrice"] floatValue];
            }
        }
        
        // Get selected salads
        if ([[order  objectForKey:@"salads"] count] > 0) {
            for (NSMutableDictionary *salad in [order objectForKey:@"salads"]) {
                    totalPrice  += [[salad objectForKey:@"itemPrice"] floatValue];
            }
        }
        
        
        // Get selected kids menu
        if ([[order  objectForKey:@"kids"] count] > 0) {
            for (NSMutableDictionary *kid in [order objectForKey:@"kids"]) {
                    totalPrice  += [[kid objectForKey:@"itemPrice"] floatValue];
            }
        }
    }    
    ///NSLog(@"Total Price = %f",totalPrice);
    
    NSString *finalPrice = [NSString stringWithFormat:@"$%.2f",totalPrice];
    
    UIAlertView *av = [[UIAlertView alloc] initWithTitle:@"Total Price" 
                            message:finalPrice
                            delegate:self 
                            cancelButtonTitle:@"Cancel" 
                            otherButtonTitles:@"Accept",nil];
    [av show];
    [av release];

}

        
        


- (IBAction)saveTableOrder:(id)sender 
{
    if (self.tableOrderList != nil && ([self.tableOrderList count] > 0)) 
    {
        [self.delegate SaveTableEntry:self.tableOrderList];

        
        NSString *employeeId = @"1";
        NSString *tableId = [NSString stringWithFormat:@"%d",selectedTable+1];
        
        NSDate * dateNow = [[NSDate alloc] init];
        NSTimeInterval timeInterval = [dateNow timeIntervalSince1970];
        NSString * dateString = [NSString stringWithFormat:@"%d",timeInterval];
        [dateNow release];
        
        int chairNumber = 0;
        for (NSMutableDictionary * order in tableOrderList) 
        {
            NSString * customerId = [NSString stringWithFormat:@"%d",chairNumber];
            chairNumber++;
            NSString *orders = @"";
            // Get selected beverages
            if ([[order  objectForKey:@"beverages"] count] > 0) {
                for (NSMutableDictionary * bev in [order objectForKey:@"beverages"]) {
                    NSString * orderItem = [bev objectForKey:@"menuItemID"];
                    orders = [orders stringByAppendingString:orderItem];
                    orders = [orders stringByAppendingString:@","];
                }
            }
            
            // Get selected entrees
            if ([[order  objectForKey:@"entrees"] count] > 0) {
                for (NSMutableDictionary *entree in [order objectForKey:@"entrees"]) {
                    NSString * orderItem = [entree objectForKey:@"menuItemID"];
                    orders = [orders stringByAppendingString:orderItem];
                    orders = [orders stringByAppendingString:@","];
                }
            }
            
            // Get selected salads
            if ([[order  objectForKey:@"salads"] count] > 0) {
                for (NSMutableDictionary *salad in [order objectForKey:@"salads"]) {
                    NSString * orderItem = [salad objectForKey:@"menuItemID"];
                    orders = [orders stringByAppendingString:orderItem];
                    orders = [orders stringByAppendingString:@","];
                }
            }
            
            
            // Get selected kids menu
            if ([[order  objectForKey:@"kids"] count] > 0) {
                for (NSMutableDictionary *kid in [order objectForKey:@"kids"]) {
                    NSString * orderItem = [kid objectForKey:@"menuItemID"];
                    orders = [orders stringByAppendingString:orderItem];
                    orders = [orders stringByAppendingString:@","];
                }
            }
            
            orders = [orders substringToIndex:[orders length]-1];
            NSLog(@"The order list %@",orders);
            
            
            [[APIManager sharedInstance] saveOrder:employeeId customer:customerId orderList:orders table:tableId timeStamp:dateString];            
        }
        
        if ([[APIManager sharedInstance] userType] == WAITER_TYPE) 
        {
            [self.navigationController popViewControllerAnimated:YES]; 
        }else{
            UIStoryboard*  sb = [UIStoryboard storyboardWithName:@"MainStoryboard_iPhone" bundle:nil];
            OrderStatusViewController * order = [sb instantiateViewControllerWithIdentifier:@"orderStatusVC"];
            [order setSelectedTable:tableId timeStamp:dateString];
            [self.navigationController pushViewController:order animated:YES];
        }
        
    }else {
        UIAlertView *av = [[UIAlertView alloc] initWithTitle:
                           @"Error." message:@"There are no orders for this table"
                                                    delegate:self 
                                           cancelButtonTitle:@"Ok" 
                                           otherButtonTitles:nil];
        [av show];
        [av release];
        
    }
}
#pragma mark- Alert Delegate
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if([alertView.title isEqual:@"Total Price"])
    {
        ////////////////////
        
        if (buttonIndex == 1)
        {
            NSString *tableId = [NSString stringWithFormat:@"%d",selectedTable+1];
            [[APIManager sharedInstance] setTableToDirty:tableId];
            [self.delegate RemoveTableEntry];
            [self.navigationController popViewControllerAnimated:YES];
            
            /* This should open the Square credit card payment app!*/
            [[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"square://"]];
        }
               
    }
    
}


@end
