//
//  CustomerOrdersTableViewController.m
//  AutoServe
//
//  Created by Eric Gilbert on 3/25/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CustomerOrdersTableViewController.h"
#import "MenuTableViewController.h"

@interface CustomerOrdersTableViewController ()

@property (nonatomic, assign) int selectedOrder;
@end

@implementation CustomerOrdersTableViewController
@synthesize tableOrderList;
@synthesize selectedOrder;
@synthesize delegate;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    tableOrderList = [[NSMutableArray alloc] initWithCapacity:0];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 2;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if (section == 0) {
        return [tableOrderList count];        
    }else {
        if ([tableOrderList count] > 0) {
            return 1;
        }
    }
    return 0;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    if (section == 0) {
        return @"Customer Order List";
    }
    return @" ";
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        
    } 
    if (indexPath.section == 0) {
        cell.textLabel.text = [NSString stringWithFormat:@"Customer %d",indexPath.row+1];
    }else{
        cell.textLabel.text = @"Submit Order";
    }
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.section == 0) {
        selectedOrder = indexPath.row;
    }else{
        [self.delegate SaveTableEntry:self];
    }
}

#pragma  mark - Customer Order Delegate
- (void)CustomerOrderDidSave:(MenuTableViewController *)controller
{
    NSLog(@"Customer order = %@",controller.customerOrder);
    [tableOrderList addObject:controller.customerOrder];
    [self.tableView reloadData];
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
	if ([segue.identifier isEqualToString:@"addOrder"])
	{
		MenuTableViewController *menuViewController =  segue.destinationViewController;
		menuViewController.delegate = self;
	}
    
	if ([segue.identifier isEqualToString:@"editOrder"])
	{
		MenuTableViewController *menuViewController =  segue.destinationViewController;
        NSLog(@"Selected Order = %d", selectedOrder);
        selectedOrder = [self.tableView indexPathForSelectedRow].row;
        [menuViewController performSelector:@selector(setOrder:) withObject:[tableOrderList objectAtIndex:selectedOrder] afterDelay:0.5];
	}
}

@end
