//
//  MenuTableViewController.m
//  AutoServe
//
//  Created by Eric Gilbert on 3/24/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MenuTableViewController.h"
#import "MenuCell.h"
#import "APIManager.h"

#define kBeveragesSection 0
#define kEntreeSelection 1
#define kSaladSelection 2
#define kKidsSelection 3
#define kPlaceOrder 4

@interface MenuTableViewController ()

@property(nonatomic, retain) NSMutableArray * beverages;
@property(nonatomic, retain) NSMutableArray * beveragesSelected;

@property(nonatomic, retain) NSMutableArray * entrees;
@property(nonatomic, retain) NSMutableArray * entreesSelected;

@property(nonatomic, retain) NSMutableArray * salads;
@property(nonatomic, retain) NSMutableArray *saladsSelected;

@property(nonatomic, retain) NSMutableArray * kids;
@property(nonatomic, retain) NSMutableArray * kidsSelected;

@property(nonatomic, retain) NSMutableArray *saladList;
@property(nonatomic, retain) NSMutableArray *kidsList;
@property(nonatomic, retain) NSMutableArray *beverageList;
@property(nonatomic, retain) NSMutableArray *entreeList;
/* Add other menu items here */

/*prototype for private methods goes here */
- (void) saveOrder;
@end

@implementation MenuTableViewController

@synthesize beverages;
@synthesize beveragesSelected;

@synthesize entrees;
@synthesize entreesSelected;

@synthesize salads;
@synthesize saladsSelected;


@synthesize kids;
@synthesize kidsSelected;

@synthesize customerOrder;

@synthesize kidsList;
@synthesize beverageList;
@synthesize entreeList;
@synthesize saladList;

@synthesize delegate;
/* Add other menu items here */




- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(processMenuList:) name:@"MENU_LOADED" object:nil];

    
    self.beverageList = [[NSMutableArray alloc] initWithCapacity:0];
    self.entreeList = [[NSMutableArray alloc] initWithCapacity:0];
    self.saladList = [[NSMutableArray alloc] initWithCapacity:0];
    self.kidsList = [[NSMutableArray alloc] initWithCapacity:0];
    
    self.customerOrder = [[NSMutableDictionary alloc] initWithCapacity:0];
    /* Add other menu items here */

    NSMutableArray * m = [[NSMutableArray alloc] initWithCapacity:0];
    self.beverages = m;
    [m release];
    
    NSMutableArray * en = [[NSMutableArray alloc] initWithCapacity:0];
    self.entrees = en;
    [en  release];
    
    NSMutableArray * sl = [[NSMutableArray alloc] initWithCapacity:0];
    self.salads = sl;
    [sl release];
    
    NSMutableArray * kd = [[NSMutableArray alloc] initWithCapacity:0];
    self.kids = kd;
    [kd release];
         
    
    self.beveragesSelected = [[NSMutableArray alloc] initWithCapacity:0];
    self.entreesSelected = [[NSMutableArray alloc] initWithCapacity:0];
    self.saladsSelected = [[NSMutableArray alloc] initWithCapacity:0];
    self.kidsSelected = [[NSMutableArray alloc] initWithCapacity:0];
    

    [[APIManager sharedInstance] getMenuItems]; 

}


- (void) processMenuList:(NSNotification *) note
{
    //NSLog (@"menu items %@",note.object);
//    [beverages removeAllObjects];
//    [entrees removeAllObjects];
//    [salads removeAllObjects];
//    [kids removeAllObjects]
    NSString *name;
    NSNumber *price;
    
    for (NSDictionary * menuItem in note.object) {
        switch ([[menuItem objectForKey:@"Category"] intValue]) {
            case kBeveragesSection:
                name = [[menuItem objectForKey:@"FoodName"] retain];
                NSMutableDictionary *bev = [[NSMutableDictionary alloc] initWithCapacity:0];
                [bev setObject:name forKey:@"name"];
                [bev setObject:[menuItem objectForKey:@"idMenu"] forKey:@"menuItemID"];
                price = [NSNumber numberWithFloat: [[menuItem objectForKey:@"Price"] floatValue]];
                [bev setObject:price forKey:@"itemPrice"];
                [self.beverages addObject:bev];
                [name release];
                break;
            case kEntreeSelection:
                name = [[menuItem objectForKey:@"FoodName"] retain];
                NSMutableDictionary *entree = [[NSMutableDictionary alloc] initWithCapacity:0];
                [entree setObject:name forKey:@"name"];
                [entree setObject:[menuItem objectForKey:@"idMenu"] forKey:@"menuItemID"];
                price = [NSNumber numberWithFloat: [[menuItem objectForKey:@"Price"] floatValue]];
                [entree setObject:price forKey:@"itemPrice"];
                [self.entrees addObject:entree];
                [name release];
                break; 
                
            case kSaladSelection:
                name = [[menuItem objectForKey:@"FoodName"] retain];
                NSMutableDictionary *salad = [[NSMutableDictionary alloc] initWithCapacity:0];
                [salad setObject:name forKey:@"name"];
                [salad setObject:[menuItem objectForKey:@"idMenu"] forKey:@"menuItemID"];
                price = [NSNumber numberWithFloat: [[menuItem objectForKey:@"Price"] floatValue]];
                [salad setObject:price forKey:@"itemPrice"];
                [self.salads addObject:salad];
                [name release];
                break; 
                
            case kKidsSelection:
                name = [[menuItem objectForKey:@"FoodName"] retain];
                NSMutableDictionary *kid = [[NSMutableDictionary alloc] initWithCapacity:0];
                [kid setObject:name forKey:@"name"];
                [kid setObject:[menuItem objectForKey:@"idMenu"] forKey:@"menuItemID"];
                price = [NSNumber numberWithFloat: [[menuItem objectForKey:@"Price"] floatValue]];
                [kid setObject:price forKey:@"itemPrice"];
                [self.kids addObject:kid];
                [name release];
                break;                 
                
            default:
                break;
        }
    }
    int x;
    
    
    for (x = 0; x!= [beverages count]; x++) {
        [beveragesSelected addObject:[NSNumber numberWithBool:NO]];
    }
    
    for (x = 0; x!= [entrees count]; x++) {
        [entreesSelected addObject:[NSNumber numberWithBool:NO]];
    }
    
    for (x = 0; x!= [salads count]; x++) {
        [saladsSelected addObject:[NSNumber numberWithBool:NO]];
    }
    
    for (x = 0; x!= [kids count]; x++) {
        [kidsSelected addObject:[NSNumber numberWithBool:NO]];
    }
    
    
    NSLog (@"beverages items %@",beverages);
    NSLog (@"entress items %@",entrees);
    NSLog (@"salads items %@",beverages);
    NSLog (@"kids items %@",kids);
   [self.tableView reloadData];
}

- (void) saveOrder
{   
    int x;
    [customerOrder removeAllObjects];
    for (x = 0; x != [beveragesSelected count]; x++) {
        if ([[beveragesSelected objectAtIndex:x] boolValue] == YES) {
            [beverageList addObject:[beverages objectAtIndex:x]];       // Get the name of beverages based on selected index x 
        }
    }
    [customerOrder setObject:beverageList forKey:@"beverages"];
    
    for (x = 0; x != [entreesSelected count]; x++) {
        if ([[entreesSelected objectAtIndex:x] boolValue] == YES) {
            [entreeList addObject:[entrees objectAtIndex:x]];         // Get the name of entree based on selected index x 
        }
    }
    [customerOrder setObject:entreeList forKey:@"entrees"];
    
    for (x = 0; x != [saladsSelected count]; x++) {
        if ([[saladsSelected objectAtIndex:x] boolValue] == YES) {
            [saladList addObject:[salads objectAtIndex:x]];         // Get the name of entree based on selected index x 
        }
    }
    [customerOrder setObject:saladList forKey:@"salads"];
    
    for (x = 0; x != [kidsSelected count]; x++) {
        if ([[kidsSelected objectAtIndex:x] boolValue] == YES) {
            [kidsList addObject:[kids objectAtIndex:x]];         // Get the name of entree based on selected index x 
        }
    }
    [customerOrder setObject:kidsList forKey:@"kids"];
    
    
    [customerOrder setObject:beveragesSelected forKey:@"bevsSelected"];
    [customerOrder setObject:entreesSelected forKey:@"entreesSelected"];
    [customerOrder setObject:saladsSelected forKey:@"saladsSelected"];
    [customerOrder setObject:kidsSelected forKey:@"kidsSelected"];
    
   /// NSLog(@"%@",customerOrder);
}

- (void) setOrder:(NSDictionary *) theOrder
{
    NSLog(@"editing this order %@",theOrder);

    beveragesSelected = [theOrder objectForKey:@"bevsSelected"];
    entreesSelected = [theOrder objectForKey:@"entreesSelected"];
    saladsSelected = [theOrder objectForKey:@"saladsSelected"];
    kidsSelected = [theOrder objectForKey:@"kidsSelected"];
    
    /* this needs to be done for all other sections in the Menu  */
    ///
    [self.tableView reloadData];
    //[self.tableView performSelector:@selector(reloadData) withObject:nil afterDelay:0.5];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{

    // Return the number of sections.
    int cnt = 0;
    if ([self.entrees count] > 0) {
        cnt++;
    }
    if ([self.salads count] > 0) {
        cnt++;
    }
    if ([self.beverages count] > 0) {
        cnt++;
    }
    if ([self.kids count] > 0) {
        cnt++;
    }
    
   
    NSLog(@"Count = %d", cnt);
    return cnt;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    switch (section)
    {
        case kBeveragesSection:
            return @"Beverages";
        case kEntreeSelection:
            return @"Entrees";
        case kSaladSelection:
            return @"Salads";
        case kKidsSelection:
            return @"Kids";
    }
    return @" ";
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{

    int rows = 0;
    switch (section) {
        case kBeveragesSection:
            rows = [beverages count];
            break;
        case kEntreeSelection:
            rows = [entrees count];
            break; 
        case kSaladSelection:
            rows = [salads count];
            
            break; 
        case kKidsSelection:
            rows = [kids count];
            break; 
        /*case 4:
            rows = 1;
            break;*/            
            
        default:
            break;
    }
    NSLog(@"rows = %d",rows);
    return rows;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    MenuCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[MenuCell alloc] init] autorelease];
        cell.frame = CGRectMake(0, 0, 320, 44);
    }
    switch (indexPath.section) {
        case kBeveragesSection:
            cell.itemName.text = [[beverages objectAtIndex:indexPath.row] objectForKey:@"name"];
            cell.checkmark.hidden = ![[beveragesSelected objectAtIndex:indexPath.row] boolValue];
            break;
        case kEntreeSelection:
            cell.itemName.text = [[entrees objectAtIndex:indexPath.row]objectForKey:@"name"];
            cell.checkmark.hidden = ![[entreesSelected objectAtIndex:indexPath.row] boolValue];
            break;
            
        case kSaladSelection:
            cell.itemName.text = [[salads objectAtIndex:indexPath.row]objectForKey:@"name"];
            cell.checkmark.hidden = ![[saladsSelected objectAtIndex:indexPath.row] boolValue];
            break;
            
        case kKidsSelection:
            cell.itemName.text = [[kids objectAtIndex:indexPath.row]objectForKey:@"name"];
            cell.checkmark.hidden = ![[kidsSelected objectAtIndex:indexPath.row] boolValue];
            break;  
            
        /*case kPlaceOrder:
            cell.itemName.text = @"Place Order";
            break;*/
            
        default:
            cell.itemName.text = [beverages objectAtIndex:indexPath.row];
            break;
    }           
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{  
    bool selected;
    switch (indexPath.section) {
        case kBeveragesSection:
            selected = [[beveragesSelected objectAtIndex:indexPath.row] boolValue];
            [beveragesSelected replaceObjectAtIndex:indexPath.row withObject:[NSNumber numberWithBool:!selected]]; 
            break;
            
        case kEntreeSelection:
            selected = [[entreesSelected objectAtIndex:indexPath.row] boolValue];
            [entreesSelected replaceObjectAtIndex:indexPath.row withObject:[NSNumber numberWithBool:!selected]]; 
            break;
            
        case kSaladSelection:
            selected = [[saladsSelected objectAtIndex:indexPath.row] boolValue];
            [saladsSelected replaceObjectAtIndex:indexPath.row withObject:[NSNumber numberWithBool:!selected]]; 
            break;
            
        case kKidsSelection:
            selected = [[kidsSelected objectAtIndex:indexPath.row] boolValue];
            [kidsSelected replaceObjectAtIndex:indexPath.row withObject:[NSNumber numberWithBool:!selected]]; 
            break;
            
        case kPlaceOrder:
            [self saveOrder];
            break;
            
        default:
            break;
    }

    [self.tableView reloadData];
}

#pragma mark -


- (IBAction)onSavePressed:(id)sender {
    [self saveOrder];
    [self.delegate CustomerOrderDidSave:self];
    [self.navigationController popViewControllerAnimated:YES];
}
@end
