//
//  OrderStatusViewController.m
//  AutoServe
//
//  Created by Michael Gilbert on 4/28/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "OrderStatusViewController.h"
#import "APIManager.h"

@interface OrderStatusViewController ()
@property (nonatomic, copy) NSString * table;
@property (nonatomic, copy) NSString * timeStamp;
@end

@implementation OrderStatusViewController
@synthesize statusLabel;
@synthesize statusImage;
@synthesize table;
@synthesize timeStamp;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) 
    {

    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(updateOrderStatus:) name:@"TABLE_STATUS" object:nil];
    
	[self performSelector:@selector(getOrderStatus) withObject:nil afterDelay:2];
}

- (void)viewDidUnload
{
    [self setStatusLabel:nil];
    [self setStatusImage:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

-(void) setSelectedTable:(NSString *) selectedTable timeStamp:(NSString *) time
{
    self.table = selectedTable;
    self.timeStamp = time;
}

- (void) getOrderStatus
{
    [[APIManager sharedInstance] getOrderStatus:table timeStamp:timeStamp];
}

- (void) updateOrderStatus:(NSNotification *) note
{
    NSArray *array = note.object;
    
    
    
    statusLabel.text = [[array objectAtIndex:0] objectForKey:@"Status"];
    int value = [statusLabel.text intValue];
    switch (value) {
        case 0:
            statusImage.image = [UIImage imageNamed:@"notstarted.png"];
            break;
        case 1:
            statusImage.image = [UIImage imageNamed:@"prepping1.png"];
            break;
        case 2:
            statusImage.image = [UIImage imageNamed:@"cooking.png"];
            break;
        case 3:
            statusImage.image = [UIImage imageNamed:@"finished.png"];
            break;

        default:
            break;
    }
    
    if (value < 3) {
        [self performSelector:@selector(getOrderStatus) withObject:nil afterDelay:2];
    }
}



- (void)dealloc {
    [statusLabel release];
    [statusImage release];
    [super dealloc];
}
@end
