//
//  TableSelectionTableViewController.m
//  AutoServe
//
//  Created by Eric Gilbert on 3/28/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "TableSelectionTableViewController.h"
#import "CustomerOrderViewController.h"
#import "TableCellView.h"

@interface TableSelectionTableViewController ()

@end

@implementation TableSelectionTableViewController
@synthesize tables;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    self.tables = [NSMutableDictionary dictionaryWithCapacity:0];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{

    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return 15;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
       // cell = [[[TableCellView alloc] init] autorelease];
        //cell.frame = CGRectMake(0, 0, 320, 44);
    }
    cell.textLabel.text  = [NSString stringWithFormat:@"Table %d",indexPath.row +1];
    
    return cell;
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{

}

-(void) SaveTableEntry:(NSMutableArray *)tableOrder
{
    int selectedTable = [self.tableView indexPathForSelectedRow].row;
    [tables setObject:tableOrder forKey:[NSNumber numberWithInt:selectedTable]];
}

-(void) RemoveTableEntry
{
    int selectedTable = [self.tableView indexPathForSelectedRow].row;
    [tables removeObjectForKey:[NSNumber numberWithInt:selectedTable]];
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
	if ([segue.identifier isEqualToString:@"tableOrder"])
	{
		CustomerOrderViewController *customerOrderVC =  segue.destinationViewController;
		customerOrderVC.delegate = self;
        customerOrderVC.selectedTable = [self.tableView indexPathForSelectedRow].row;
        int selectedTable = [self.tableView indexPathForSelectedRow].row;
        if([tables objectForKey:[NSNumber numberWithInt:selectedTable]] != nil)
        {
            [customerOrderVC loadTableOrder:[tables objectForKey:[NSNumber numberWithInt:selectedTable]]];
        }
	}

}

@end
